package il.ac.tau.cs.sw1.ex8.wordsRank;

import java.util.List;

public class FileIndexTester {
	
	public static final String SMALL_TEST_FOLDER = "data1";
	public static void main(String[] args){
		FileIndex fIndex = new FileIndex();
		fIndex.index(SMALL_TEST_FOLDER);
		try {
			if (fIndex.getCountInFile("rocky1.txt", "Rocky") != 5) {
				printErrorNum(1);
			}
			if (fIndex.getRankForWordInFile("rocky3.txt", "and") != 1){
				printErrorNum(2);
			}

		} catch (FileIndexException e) {
			printErrorNum(3);
		}
		try{
			fIndex.getRankForWordInFile("help.txt", "rocky"); //non existing file
			printErrorNum(4);
		}
		catch (FileIndexException e) {
		}
		
		//in rocky1.txt: rank = 1, in rocky2.txt: rank = 4, in rocky3.txt: rank = 2
		if (fIndex.getAverageRankForWord("rocky") != Math.round((1+4+2)/3.)){
			printErrorNum(6);
		}

		List<String> topByMin = fIndex.getTopKWordsByMinRank(4);
		if (!topByMin.contains("rocky") || !topByMin.contains("and") || !topByMin.contains("his")){
			printErrorNum(7);
		}
		List<String> topByMax = fIndex.getTopKWordsByMaxRank(2);
		if (!topByMax.get(0).equals("rocky") && !topByMax.get(1).equals("in")){
			printErrorNum(8);
		}
		

		
		
		System.out.println("Done!");
		System.out.println(fIndex.getTopKWordsByMaxRank(1));
	}
	
	private static void printErrorNum(int num){
		System.out.println("ERROR " + num);
	}
}
